meal_plans/urls.py
from django.urls import path

from meal_plans.views import (
    PlansListView,
    PlansCreateView,
    PlansDetailView,
    PlansUpdateView,
    PlansDeleteView,
)


urlpatterns = [
    path("", PlansListView.as_view(), name="meal_plans"),
    path("create/", PlansCreateView.as_view(), name="plans_new"),
    path("<int:pk>/", PlansDetailView.as_view(), name="plans_detail"),
    path("<int:pk>/edit/", PlansUpdateView.as_view(), name="plans_edit"),
    path("<int:pk>/delete/", PlansDeleteView.as_view(), name="plans_delete"),
]

scrumptious/urls.py
from django.contrib import admin
from django.urls import include, path, reverse_lazy
from django.views.generic.base import RedirectView
from django.contrib.auth import views as auth_views


urlpatterns = [
    path("admin/", admin.site.urls),
    path("recipes/", include("recipes.urls")),
    path("tags/", include("tags.urls")),
    path(
        "",
        RedirectView.as_view(url=reverse_lazy("recipes_list")),
        name="home",
    ),
    path("accounts/login/", auth_views.LoginView.as_view(), name="login"),
    path("accounts/logout/", auth_views.LogoutView.as_view(), name="logout"),
    path("meal_plans/", include("meal_plans.urls")),
]

tags/urls.py
from django.urls import path

from tags.views import (
    TagListView,
    TagDeleteView,
    TagDetailView,
    TagCreateView,
    TagUpdateView,
)

urlpatterns = [
    path("", TagListView.as_view(), name="tags_list"),
    path("<int:pk>/", TagDetailView.as_view(), name="tag_detail"),
    path("<int:pk>/delete/", TagDeleteView.as_view(), name="tag_delete"),
    path("new/", TagCreateView.as_view(), name="tag_new"),
    path("<int:pk>/edit/", TagUpdateView.as_view(), name="tag_edit"),
]

meal_plans/models.py
from time import timezone
from django.db import models
from django.conf import settings
from django.utils import timezone

USER_MODEL = settings.AUTH_USER_MODEL


# Create your models here.
class MealPlan(models.Model):
    name = models.CharField(max_length=120)
    date = models.DateTimeField(default=timezone.now)
    owner = models.ForeignKey(USER_MODEL, on_delete=models.CASCADE, null=True)
    recipes = models.ManyToManyField(
        "recipes.Recipe", related_name="meal_plans"
    )

    def __str__(self):
        return self.name

meal_plans/views.py
from django.http import Http404
from django.urls import reverse_lazy
from django.views.generic import (
    DetailView,
    CreateView,
    ListView,
    UpdateView,
    DeleteView,
)
from meal_plans.models import MealPlan
from django.contrib.auth.mixins import LoginRequiredMixin


# Create your views here.


class PlansListView(ListView):
    model = MealPlan
    template_name = "plans/list.html"
    paginate_by = 2


class PlansCreateView(
    LoginRequiredMixin, CreateView
):  # shows up in meal_plans/create/
    model = MealPlan
    template_name = "plans/new.html"
    fields = ["name", "date", "recipes"]
    success_url = reverse_lazy("meal_plans")

    def form_valid(self, form):
        form.instance.owner = self.request.user
        return super().form_valid(form)


class PlansDetailView(DetailView):
    model = MealPlan
    template_name = "plans/detail.html"

    def get_queryset(self):
        return MealPlan.objects.filter(owner=self.request.user)


class PlansUpdateView(LoginRequiredMixin, UpdateView):
    model = MealPlan
    template_name = "plans/edit.html"
    fields = ["name", "date", "recipes"]
    success_url = reverse_lazy("meal_plans")

    def get_queryset(self):
        return MealPlan.objects.filter(owner=self.request.user)


class PlansDeleteView(LoginRequiredMixin, DeleteView):
    model = MealPlan
    template_name = "plans/delete.html"
    success_url = reverse_lazy("meal_plans")

    def get_queryset(self):
        return MealPlan.objects.filter(owner=self.request.user)

meal_plans/templates/plans/delete.html
{% extends 'base.html' %}
{% block content %}
  <main>
    <div class="delete-form">
      <form method="post">
          {% csrf_token %}
          <p>Are you sure you want to delete "{{ mealplan.name }}"?</p>
          {{ form.as_p }}
          <div>
            <button class="button">Delete</button>
          </div>
      </form>
      
  </main>
{% endblock %}

meal_plans/templates/plans/detail.html
{% extends 'base.html' %}

{% block content %}
    <main class="plan-detail">
        <div>
            <a href="{% url 'plans_edit' mealplan.pk %}">Edit</a>
            <a href="{% url 'plans_delete' mealplan.pk %}">Delete</a>
        </div>
        
        <h1>{{ mealplan.name }}</h1>
        <p>Served on: {{ mealplan.date }}</p>

        <div class="recipes-list">
            <p>Recipes: </p>
            {% for recipe in mealplan.recipes.all %}
                <a href="{% url 'recipe_detail' recipe.pk %}">{{ recipe.name }}, </a>
            {% endfor %}
        </div>
    </main>
{% endblock content %}

meal_plans/templates/plans/edit.html
{% extends 'base.html' %}
{% block content %}
  <main class="plan-form">
      <form method="post">
        {% csrf_token %}
        {{ form.as_p }}
        <div class="control">
          <button class="button">Create</button>
        </div>
      </form>
  </main>
{% endblock content%}           

meal_plans/templates/plans/list.html
{% extends 'pagination.html' %}

{% block content %}
    <main>
        <h2>Here are your meal plans:</h2>
        {% for meal_plan in mealplan_list %}
        <div>
            <ul>
                <li>Meal plan: <a href="{% url 'plans_detail' meal_plan.pk %}">{{ meal_plan.name }}</a></li>
            </ul>
        </div>
        {% endfor %}
    </main>
{% endblock content %}

meal_plans/templates/plans/new.html
{% extends 'base.html' %}
{% block content %}
  <main class="plan-form">
    <form method="post">
      {% csrf_token %}
      {{ form.as_p }}
      <div class="control">
        <button class="button">Create</button>
      </div>
    </form>
  </main>
{% endblock content%}